Index: uspace/app/viewer/viewer.c
===================================================================
--- uspace/app/viewer/viewer.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/viewer/viewer.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2013 Martin Decky
  * All rights reserved.
@@ -40,4 +40,5 @@
 #include <stdlib.h>
 #include <str.h>
+#include <ui/filedialog.h>
 #include <ui/image.h>
 #include <ui/ui.h>
@@ -50,20 +51,24 @@
 typedef struct {
 	ui_t *ui;
+
+	size_t imgs_count;
+	size_t imgs_current;
+	char **imgs;
+
+	bool fullscreen;
+	ui_window_t *window;
+	gfx_bitmap_t *bitmap;
+	ui_image_t *image;
+	gfx_context_t *window_gc;
+	ui_file_dialog_t *dialog;
+
+	gfx_rect_t img_rect;
 } viewer_t;
 
-static size_t imgs_count;
-static size_t imgs_current = 0;
-static char **imgs;
-
-static ui_window_t *window;
-static gfx_bitmap_t *bitmap = NULL;
-static ui_image_t *image = NULL;
-static gfx_context_t *window_gc;
-
-static gfx_rect_t img_rect;
-
-static bool img_load(gfx_context_t *gc, const char *, gfx_bitmap_t **,
+static bool viewer_img_load(viewer_t *, const char *, gfx_bitmap_t **,
     gfx_rect_t *);
-static bool img_setup(gfx_context_t *, gfx_bitmap_t *, gfx_rect_t *);
+static bool viewer_img_setup(viewer_t *, gfx_bitmap_t *, gfx_rect_t *);
+static errno_t viewer_window_create(viewer_t *);
+static void viewer_window_destroy(viewer_t *);
 
 static void wnd_close(ui_window_t *, void *);
@@ -75,4 +80,14 @@
 };
 
+static void file_dialog_bok(ui_file_dialog_t *, void *, const char *);
+static void file_dialog_bcancel(ui_file_dialog_t *, void *);
+static void file_dialog_close(ui_file_dialog_t *, void *);
+
+static ui_file_dialog_cb_t file_dialog_cb = {
+	.bok = file_dialog_bok,
+	.bcancel = file_dialog_bcancel,
+	.close = file_dialog_close
+};
+
 /** Window close request
  *
@@ -87,26 +102,30 @@
 }
 
-static void wnd_kbd_event(ui_window_t *window, void *arg,
-    kbd_event_t *event)
+/** Viewer unmodified key press.
+ *
+ * @param viewer Viewer
+ * @param event Keyboard event
+ */
+static void viewer_kbd_event_unmod(viewer_t *viewer, kbd_event_t *event)
 {
 	bool update = false;
 
-	if ((event->type == KEY_PRESS) && (event->c == 'q'))
-		exit(0);
-
-	if ((event->type == KEY_PRESS) && (event->key == KC_PAGE_DOWN)) {
-		if (imgs_current == imgs_count - 1)
-			imgs_current = 0;
+	if (event->key == KC_Q || event->key == KC_ESCAPE)
+		ui_quit(viewer->ui);
+
+	if (event->key == KC_PAGE_DOWN) {
+		if (viewer->imgs_current == viewer->imgs_count - 1)
+			viewer->imgs_current = 0;
 		else
-			imgs_current++;
+			viewer->imgs_current++;
 
 		update = true;
 	}
 
-	if ((event->type == KEY_PRESS) && (event->key == KC_PAGE_UP)) {
-		if (imgs_current == 0)
-			imgs_current = imgs_count - 1;
+	if (event->key == KC_PAGE_UP) {
+		if (viewer->imgs_current == 0)
+			viewer->imgs_current = viewer->imgs_count - 1;
 		else
-			imgs_current--;
+			viewer->imgs_current--;
 
 		update = true;
@@ -117,10 +136,13 @@
 		gfx_rect_t lrect;
 
-		if (!img_load(window_gc, imgs[imgs_current], &lbitmap, &lrect)) {
-			printf("Cannot load image \"%s\".\n", imgs[imgs_current]);
+		if (!viewer_img_load(viewer, viewer->imgs[viewer->imgs_current],
+		    &lbitmap, &lrect)) {
+			printf("Cannot load image \"%s\".\n",
+			    viewer->imgs[viewer->imgs_current]);
 			exit(4);
 		}
-		if (!img_setup(window_gc, lbitmap, &lrect)) {
-			printf("Cannot setup image \"%s\".\n", imgs[imgs_current]);
+		if (!viewer_img_setup(viewer, lbitmap, &lrect)) {
+			printf("Cannot setup image \"%s\".\n",
+			    viewer->imgs[viewer->imgs_current]);
 			exit(6);
 		}
@@ -128,5 +150,101 @@
 }
 
-static bool img_load(gfx_context_t *gc, const char *fname,
+/** Viewer ctrl-key key press.
+ *
+ * @param viewer Viewer
+ * @param event Keyboard event
+ */
+static void viewer_kbd_event_ctrl(viewer_t *viewer, kbd_event_t *event)
+{
+	if (event->key == KC_Q)
+		ui_quit(viewer->ui);
+}
+
+/** Viewer window keyboard event.
+ *
+ * @param window UI window
+ * @param arg Argument (viewer_t *)
+ * @param event Keyboard event
+ */
+static void wnd_kbd_event(ui_window_t *window, void *arg,
+    kbd_event_t *event)
+{
+	viewer_t *viewer = (viewer_t *)arg;
+
+	if (event->type != KEY_PRESS)
+		return;
+
+	if ((event->mods & (KM_CTRL | KM_ALT | KM_SHIFT)) == 0)
+		viewer_kbd_event_unmod(viewer, event);
+
+	if ((event->mods & KM_CTRL) != 0 &&
+	    (event->mods & (KM_ALT | KM_SHIFT)) == 0)
+		viewer_kbd_event_ctrl(viewer, event);
+
+	ui_window_def_kbd(window, event);
+}
+
+/** File dialog OK button press.
+ *
+ * @param dialog File dialog
+ * @param arg Argument (viewer_t *)
+ * @param fname File name
+ */
+static void file_dialog_bok(ui_file_dialog_t *dialog, void *arg,
+    const char *fname)
+{
+	viewer_t *viewer = (viewer_t *) arg;
+	errno_t rc;
+
+	viewer->imgs_count = 1;
+	viewer->imgs = calloc(viewer->imgs_count, sizeof(char *));
+	if (viewer->imgs == NULL) {
+		printf("Out of memory.\n");
+		ui_quit(viewer->ui);
+		return;
+	}
+
+	viewer->imgs[0] = str_dup(fname);
+	if (viewer->imgs[0] == NULL) {
+		printf("Out of memory.\n");
+		ui_quit(viewer->ui);
+		return;
+	}
+
+	rc = viewer_window_create(viewer);
+	if (rc != EOK)
+		ui_quit(viewer->ui);
+
+	ui_file_dialog_destroy(dialog);
+	viewer->dialog = NULL;
+}
+
+/** File dialog cancel button press.
+ *
+ * @param dialog File dialog
+ * @param arg Argument (viewer_t *)
+ */
+static void file_dialog_bcancel(ui_file_dialog_t *dialog, void *arg)
+{
+	viewer_t *viewer = (viewer_t *) arg;
+
+	ui_file_dialog_destroy(dialog);
+	ui_quit(viewer->ui);
+}
+
+/** File dialog close request.
+ *
+ * @param dialog File dialog
+ * @param arg Argument (viewer_t *)
+ */
+static void file_dialog_close(ui_file_dialog_t *dialog, void *arg)
+{
+	viewer_t *viewer = (viewer_t *) arg;
+
+	ui_file_dialog_destroy(dialog);
+	ui_quit(viewer->ui);
+}
+
+static bool viewer_img_load(viewer_t *viewer, const char *fname,
     gfx_bitmap_t **rbitmap, gfx_rect_t *rect)
 {
@@ -159,5 +277,5 @@
 	vfs_put(fd);
 
-	rc = decode_tga(gc, tga, stat.size, rbitmap, rect);
+	rc = decode_tga(viewer->window_gc, tga, stat.size, rbitmap, rect);
 	if (rc != EOK) {
 		free(tga);
@@ -167,9 +285,10 @@
 	free(tga);
 
-	img_rect = *rect;
+	viewer->img_rect = *rect;
 	return true;
 }
 
-static bool img_setup(gfx_context_t *gc, gfx_bitmap_t *bmp, gfx_rect_t *rect)
+static bool viewer_img_setup(viewer_t *viewer, gfx_bitmap_t *bmp,
+    gfx_rect_t *rect)
 {
 	gfx_rect_t arect;
@@ -178,17 +297,17 @@
 	errno_t rc;
 
-	ui_res = ui_window_get_res(window);
-
-	ui_window_get_app_rect(window, &arect);
+	ui_res = ui_window_get_res(viewer->window);
+
+	ui_window_get_app_rect(viewer->window, &arect);
 
 	/* Center image on application area */
 	gfx_rect_ctr_on_rect(rect, &arect, &irect);
 
-	if (image != NULL) {
-		ui_image_set_bmp(image, bmp, rect);
-		(void) ui_image_paint(image);
-		ui_image_set_rect(image, &irect);
+	if (viewer->image != NULL) {
+		ui_image_set_bmp(viewer->image, bmp, rect);
+		(void) ui_image_paint(viewer->image);
+		ui_image_set_rect(viewer->image, &irect);
 	} else {
-		rc = ui_image_create(ui_res, bmp, rect, &image);
+		rc = ui_image_create(ui_res, bmp, rect, &viewer->image);
 		if (rc != EOK) {
 			gfx_bitmap_destroy(bmp);
@@ -196,12 +315,12 @@
 		}
 
-		ui_image_set_rect(image, &irect);
-		ui_window_add(window, ui_image_ctl(image));
-	}
-
-	if (bitmap != NULL)
-		gfx_bitmap_destroy(bitmap);
-
-	bitmap = bmp;
+		ui_image_set_rect(viewer->image, &irect);
+		ui_window_add(viewer->window, ui_image_ctl(viewer->image));
+	}
+
+	if (viewer->bitmap != NULL)
+		gfx_bitmap_destroy(viewer->bitmap);
+
+	viewer->bitmap = bmp;
 	return true;
 }
@@ -214,68 +333,13 @@
 }
 
-int main(int argc, char *argv[])
-{
-	const char *display_spec = DISPLAY_DEFAULT;
+static errno_t viewer_window_create(viewer_t *viewer)
+{
+	ui_wnd_params_t params;
 	gfx_bitmap_t *lbitmap;
 	gfx_rect_t lrect;
-	bool fullscreen = false;
-	gfx_rect_t rect;
 	gfx_rect_t wrect;
 	gfx_coord2_t off;
-	ui_t *ui;
-	ui_wnd_params_t params;
-	viewer_t viewer;
+	gfx_rect_t rect;
 	errno_t rc;
-	int i;
-
-	i = 1;
-	while (i < argc && argv[i][0] == '-') {
-		if (str_cmp(argv[i], "-d") == 0) {
-			++i;
-			if (i >= argc) {
-				printf("Argument missing.\n");
-				print_syntax();
-				return 1;
-			}
-
-			display_spec = argv[i++];
-		} else if (str_cmp(argv[i], "-f") == 0) {
-			++i;
-			fullscreen = true;
-		} else {
-			printf("Invalid option '%s'.\n", argv[i]);
-			print_syntax();
-			return 1;
-		}
-	}
-
-	if (i >= argc) {
-		printf("No image files specified.\n");
-		print_syntax();
-		return 1;
-	}
-
-	imgs_count = argc - i;
-	imgs = calloc(imgs_count, sizeof(char *));
-	if (imgs == NULL) {
-		printf("Out of memory.\n");
-		return 1;
-	}
-
-	for (int j = 0; j < argc - i; j++) {
-		imgs[j] = str_dup(argv[i + j]);
-		if (imgs[j] == NULL) {
-			printf("Out of memory.\n");
-			return 3;
-		}
-	}
-
-	rc = ui_create(display_spec, &ui);
-	if (rc != EOK) {
-		printf("Error creating UI on display %s.\n", display_spec);
-		return 1;
-	}
-
-	viewer.ui = ui;
 
 	/*
@@ -290,22 +354,24 @@
 	params.rect.p1.y = 1;
 
-	if (fullscreen) {
+	if (viewer->fullscreen) {
 		params.style &= ~ui_wds_decorated;
 		params.placement = ui_wnd_place_full_screen;
 	}
 
-	rc = ui_window_create(ui, &params, &window);
+	rc = ui_window_create(viewer->ui, &params, &viewer->window);
 	if (rc != EOK) {
 		printf("Error creating window.\n");
-		return 1;
-	}
-
-	window_gc = ui_window_get_gc(window);
-
-	ui_window_set_cb(window, &window_cb, (void *) &viewer);
-
-	if (!img_load(window_gc, imgs[imgs_current], &lbitmap, &lrect)) {
-		printf("Cannot load image \"%s\".\n", imgs[imgs_current]);
-		return 1;
+		goto error;
+	}
+
+	viewer->window_gc = ui_window_get_gc(viewer->window);
+
+	ui_window_set_cb(viewer->window, &window_cb, (void *)viewer);
+
+	if (!viewer_img_load(viewer, viewer->imgs[viewer->imgs_current],
+	    &lbitmap, &lrect)) {
+		printf("Cannot load image \"%s\".\n",
+		    viewer->imgs[viewer->imgs_current]);
+		goto error;
 	}
 
@@ -314,30 +380,153 @@
 	 * to rect
 	 */
-	ui_wdecor_rect_from_app(params.style, &lrect, &wrect);
+	ui_wdecor_rect_from_app(viewer->ui, params.style, &lrect, &wrect);
 	off = wrect.p0;
 	gfx_rect_rtranslate(&off, &wrect, &rect);
 
-	if (!fullscreen) {
-		rc = ui_window_resize(window, &rect);
+	if (!viewer->fullscreen) {
+		rc = ui_window_resize(viewer->window, &rect);
 		if (rc != EOK) {
 			printf("Error resizing window.\n");
-			return 1;
-		}
-	}
-
-	if (!img_setup(window_gc, lbitmap, &lrect)) {
-		printf("Cannot setup image \"%s\".\n", imgs[imgs_current]);
-		return 1;
-	}
-
-	rc = ui_window_paint(window);
+			goto error;
+		}
+	}
+
+	if (!viewer_img_setup(viewer, lbitmap, &lrect)) {
+		printf("Cannot setup image \"%s\".\n",
+		    viewer->imgs[viewer->imgs_current]);
+		goto error;
+	}
+
+	rc = ui_window_paint(viewer->window);
 	if (rc != EOK) {
 		printf("Error painting window.\n");
-		return 1;
+		goto error;
+	}
+
+	return EOK;
+error:
+	viewer_window_destroy(viewer);
+	ui_quit(viewer->ui);
+	return rc;
+}
+
+static void viewer_window_destroy(viewer_t *viewer)
+{
+	if (viewer->window != NULL)
+		ui_window_destroy(viewer->window);
+	viewer->window = NULL;
+}
+
+int main(int argc, char *argv[])
+{
+	const char *display_spec = UI_ANY_DEFAULT;
+	ui_t *ui = NULL;
+	viewer_t *viewer;
+	errno_t rc;
+	int i;
+	unsigned u;
+	ui_file_dialog_params_t fdparams;
+
+	viewer = calloc(1, sizeof(viewer_t));
+	if (viewer == NULL) {
+		printf("Out of memory.\n");
+		goto error;
+	}
+
+	i = 1;
+	while (i < argc && argv[i][0] == '-') {
+		if (str_cmp(argv[i], "-d") == 0) {
+			++i;
+			if (i >= argc) {
+				printf("Argument missing.\n");
+				print_syntax();
+				goto error;
+			}
+
+			display_spec = argv[i++];
+		} else if (str_cmp(argv[i], "-f") == 0) {
+			++i;
+			viewer->fullscreen = true;
+		} else {
+			printf("Invalid option '%s'.\n", argv[i]);
+			print_syntax();
+			goto error;
+		}
+	}
+
+	/* Images specified? */
+	if (i < argc) {
+		viewer->imgs_count = argc - i;
+		viewer->imgs = calloc(viewer->imgs_count, sizeof(char *));
+		if (viewer->imgs == NULL) {
+			printf("Out of memory.\n");
+			goto error;
+		}
+
+		for (int j = 0; j < argc - i; j++) {
+			viewer->imgs[j] = str_dup(argv[i + j]);
+			if (viewer->imgs[j] == NULL) {
+				printf("Out of memory.\n");
+				goto error;
+			}
+		}
+	}
+
+	rc = ui_create(display_spec, &ui);
+	if (rc != EOK) {
+		printf("Error creating UI on display %s.\n", display_spec);
+		goto error;
+	}
+
+	if (ui_is_fullscreen(ui))
+		viewer->fullscreen = true;
+
+	viewer->ui = ui;
+
+	if (viewer->imgs != NULL) {
+		/* We have images, create viewer window. */
+		rc = viewer_window_create(viewer);
+		if (rc != EOK)
+			goto error;
+	} else {
+		/* No images specified, browse for one. */
+		ui_file_dialog_params_init(&fdparams);
+		fdparams.caption = "Open Image";
+
+		rc = ui_file_dialog_create(viewer->ui, &fdparams,
+		    &viewer->dialog);
+		if (rc != EOK) {
+			printf("Error creating file dialog.\n");
+			goto error;
+		}
+
+		ui_file_dialog_set_cb(viewer->dialog, &file_dialog_cb,
+		    (void *)viewer);
 	}
 
 	ui_run(ui);
 
+	ui_window_destroy(viewer->window);
+	ui_destroy(ui);
+	free(viewer);
+
 	return 0;
+error:
+	if (viewer != NULL && viewer->dialog != NULL)
+		ui_file_dialog_destroy(viewer->dialog);
+	if (viewer != NULL && viewer->imgs != NULL) {
+		for (u = 0; u < viewer->imgs_count; u++) {
+			if (viewer->imgs[i] != NULL)
+				free(viewer->imgs[i]);
+		}
+		free(viewer->imgs);
+	}
+	if (viewer != NULL)
+		viewer_window_destroy(viewer);
+	if (ui != NULL)
+		ui_destroy(ui);
+	if (viewer != NULL)
+		free(viewer);
+	return 1;
 }
 
Index: uspace/app/wifi_supplicant/wifi_supplicant.c
===================================================================
--- uspace/app/wifi_supplicant/wifi_supplicant.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/wifi_supplicant/wifi_supplicant.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -75,15 +75,9 @@
 }
 
-static char *nic_addr_format(nic_address_t *addr)
-{
-	char *str;
-	int rc = asprintf(&str, "%02x:%02x:%02x:%02x:%02x:%02x",
+static void nic_addr_format(nic_address_t *addr, char *out, size_t out_size)
+{
+	snprintf(out, out_size, "%02x:%02x:%02x:%02x:%02x:%02x",
 	    addr->address[0], addr->address[1], addr->address[2],
 	    addr->address[3], addr->address[4], addr->address[5]);
-
-	if (rc < 0)
-		return NULL;
-
-	return str;
 }
 
@@ -263,7 +257,9 @@
 	for (uint8_t i = 0; i < scan_results.length; i++) {
 		ieee80211_scan_result_t result = scan_results.results[i];
+		char mac_addr_hex[18];
+		nic_addr_format(&result.bssid, mac_addr_hex, 18);
 
 		printf("%16.16s %17s %4d %5s %5s %7s %7s\n",
-		    result.ssid, nic_addr_format(&result.bssid),
+		    result.ssid, mac_addr_hex,
 		    result.channel,
 		    enum_name(ieee80211_security_type_strs, result.security.type),
Index: uspace/drv/audio/hdaudio/codec.c
===================================================================
--- uspace/drv/audio/hdaudio/codec.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/audio/hdaudio/codec.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2014 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -512,4 +512,5 @@
 	codec->address = address;
 	codec->in_aw = -1;
+	codec->out_aw = -1;
 
 	rc = hda_get_subnc(codec, 0, &sfg, &nfg);
@@ -584,6 +585,4 @@
 					goto error;
 			} else if (awtype == awt_audio_output) {
-				codec->out_aw_list[codec->out_aw_num++] = aw;
-
 				rc = hda_get_supp_rates(codec, aw, &rates);
 				if (rc != EOK)
@@ -594,6 +593,18 @@
 					goto error;
 
-				ddf_msg(LVL_DEBUG, "Output widget %d: rates=0x%x formats=0x%x",
+				if (rates != 0 && formats != 0 &&
+				    codec->out_aw < 0) {
+					ddf_msg(LVL_DEBUG, "Selected output "
+					    "widget %d\n", aw);
+					codec->out_aw = aw;
+				} else {
+					ddf_msg(LVL_DEBUG, "Ignoring output "
+					    "widget %d\n", aw);
+				}
+
+				ddf_msg(LVL_NOTE, "Output widget %d: rates=0x%x formats=0x%x",
 				    aw, rates, formats);
+				codec->out_aw_rates = rates;
+				codec->out_aw_formats = formats;
 			} else if (awtype == awt_audio_input) {
 				if (codec->in_aw < 0) {
@@ -616,4 +627,6 @@
 				ddf_msg(LVL_DEBUG, "Input widget %d: rates=0x%x formats=0x%x",
 				    aw, rates, formats);
+				codec->in_aw_rates = rates;
+				codec->in_aw_formats = formats;
 			}
 
@@ -644,22 +657,16 @@
 {
 	errno_t rc;
-	int out_aw;
-	int i;
-
-	for (i = 0; i < codec->out_aw_num; i++) {
-		out_aw = codec->out_aw_list[i];
-
-		/* Configure converter */
-
-		ddf_msg(LVL_DEBUG, "Configure output converter format");
-		rc = hda_set_converter_fmt(codec, out_aw, stream->fmt);
-		if (rc != EOK)
-			goto error;
-
-		ddf_msg(LVL_DEBUG, "Configure output converter stream, channel");
-		rc = hda_set_converter_ctl(codec, out_aw, stream->sid, 0);
-		if (rc != EOK)
-			goto error;
-	}
+
+	/* Configure converter */
+	ddf_msg(LVL_DEBUG, "Configure output converter format / %d",
+	    codec->out_aw);
+	rc = hda_set_converter_fmt(codec, codec->out_aw, stream->fmt);
+	if (rc != EOK)
+		goto error;
+
+	ddf_msg(LVL_DEBUG, "Configure output converter stream, channel");
+	rc = hda_set_converter_ctl(codec, codec->out_aw, stream->sid, 0);
+	if (rc != EOK)
+		goto error;
 
 	return EOK;
Index: uspace/drv/audio/hdaudio/codec.h
===================================================================
--- uspace/drv/audio/hdaudio/codec.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/audio/hdaudio/codec.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2014 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -39,13 +39,15 @@
 #include "stream.h"
 
-#define MAX_OUT_AW 256
-
 typedef struct hda_codec {
 	hda_t *hda;
 	uint8_t address;
-	uint8_t out_aw_list[MAX_OUT_AW];
+	int out_aw;
+	uint32_t out_aw_rates;
+	uint32_t out_aw_formats;
 	int out_aw_num;
 	int out_aw_sel;
 	int in_aw;
+	uint32_t in_aw_rates;
+	uint32_t in_aw_formats;
 } hda_codec_t;
 
Index: uspace/drv/audio/hdaudio/hdactl.c
===================================================================
--- uspace/drv/audio/hdaudio/hdactl.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/audio/hdaudio/hdactl.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2014 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -670,6 +670,28 @@
 }
 
+static void hda_ctl_check_fifo_error(hda_ctl_t *ctl)
+{
+	int i;
+	uint8_t sts;
+
+	/*
+	 * XXX Ideally the interrupt handler would tell us which stream
+	 * has the error.
+	 */
+
+	for (i = 0; i < 30; i++) {
+		sts = hda_reg8_read(&ctl->hda->regs->sdesc[i].sts);
+		if ((sts & BIT_V(uint8_t, sdsts_fifoe)) != 0 && (sts & 0x80) == 0) {
+			ddf_msg(LVL_WARN, "sts[%d] = 0x%hhx\n", i, sts);
+			hda_reg8_write(&ctl->hda->regs->sdesc[i].sts,
+			    BIT_V(uint8_t, sdsts_fifoe));
+		}
+	}
+}
+
 void hda_ctl_interrupt(hda_ctl_t *ctl)
 {
+	ddf_msg(LVL_DEBUG, "hda_ctl_interrupt");
+	hda_ctl_check_fifo_error(ctl);
 	hda_ctl_process_rirb(ctl);
 }
Index: uspace/drv/audio/hdaudio/hdaudio.c
===================================================================
--- uspace/drv/audio/hdaudio/hdaudio.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/audio/hdaudio/hdaudio.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2014 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -58,5 +58,5 @@
 static errno_t hda_fun_offline(ddf_fun_t *fun);
 
-static void hdaudio_interrupt(ipc_call_t *, ddf_dev_t *);
+static void hdaudio_interrupt(ipc_call_t *, void *);
 
 static driver_ops_t driver_ops = {
@@ -140,5 +140,5 @@
 		.cmd = CMD_PIO_WRITE_8,
 		.addr = NULL, /* sdesc[x].sts */
-		.value = 0x4 /* XXX sdesc.sts.BCIS */
+		.value = BIT_V(uint8_t, sdsts_bcis)
 	},
 	/* 4 */
@@ -266,5 +266,5 @@
 	cap_irq_handle_t irq_cap;
 	rc = register_interrupt_handler(dev, res.irqs.irqs[0],
-	    hdaudio_interrupt, &irq_code, &irq_cap);
+	    hdaudio_interrupt, (void *)hda, &irq_code, &irq_cap);
 	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Failed registering interrupt handler: %s",
@@ -377,7 +377,12 @@
 }
 
-static void hdaudio_interrupt(ipc_call_t *icall, ddf_dev_t *dev)
-{
-	hda_t *hda = (hda_t *)ddf_dev_data_get(dev);
+/** HD Audio interrupt handler.
+ *
+ * @param icall IRQ event notification
+ * @param arg Argument (hda_t *)
+ */
+static void hdaudio_interrupt(ipc_call_t *icall, void *arg)
+{
+	hda_t *hda = (hda_t *)arg;
 
 	if (0)
Index: uspace/drv/audio/hdaudio/pcm_iface.c
===================================================================
--- uspace/drv/audio/hdaudio/pcm_iface.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/audio/hdaudio/pcm_iface.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2014 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -132,5 +132,5 @@
 	    *channels, *rate, *format);
 
-	if (*channels != 1) {
+	if (*channels != 2) {
 		*channels = 2;
 		rc = ELIMIT;
Index: uspace/drv/audio/hdaudio/spec/regs.h
===================================================================
--- uspace/drv/audio/hdaudio/spec/regs.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/audio/hdaudio/spec/regs.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2014 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -165,4 +165,5 @@
 } hda_regs_t;
 
+/** Stream Descriptor Control bits */
 typedef enum {
 	/** Descriptor Error Interrupt Enable */
@@ -177,4 +178,16 @@
 	sdctl1_srst = 0
 } hda_sdesc_ctl1_bits;
+
+/** Stream Descriptor Status bits */
+typedef enum {
+	/** FIFO Ready */
+	sdctl1_fifordy = 3,
+	/** Descriptor Error */
+	sdsts_dese = 2,
+	/** FIFO Error */
+	sdsts_fifoe = 1,
+	/** Buffer Completion Interrupt Status */
+	sdsts_bcis = 2
+} hda_sdesc_sts_bits;
 
 typedef enum {
Index: uspace/drv/audio/hdaudio/stream.c
===================================================================
--- uspace/drv/audio/hdaudio/stream.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/audio/hdaudio/stream.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2014 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -166,6 +166,9 @@
 	uint8_t ctl3;
 
+	/* Stream ID */
 	ctl3 = (stream->sid << 4);
-	ctl1 = 0x4;
+
+	/* Interrupt on buffer completion */
+	ctl1 = BIT_V(uint8_t, sdctl1_ioce);
 
 	sdregs = &stream->hda->regs->sdesc[stream->sdid];
Index: uspace/drv/audio/sb16/main.c
===================================================================
--- uspace/drv/audio/sb16/main.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/audio/sb16/main.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -76,7 +76,12 @@
 }
 
-static void irq_handler(ipc_call_t *call, ddf_dev_t *dev)
-{
-	sb16_t *sb16_dev = ddf_dev_data_get(dev);
+/** SB16 IRQ handler.
+ *
+ * @param call IRQ event notification
+ * @param arg Argument (sb16_t *)
+ */
+static void irq_handler(ipc_call_t *call, void *arg)
+{
+	sb16_t *sb16_dev = (sb16_t *)arg;
 	sb16_interrupt(sb16_dev);
 }
@@ -124,5 +129,5 @@
 
 	rc = register_interrupt_handler(device, irq, irq_handler,
-	    &irq_code, &irq_cap);
+	    (void *)soft_state, &irq_code, &irq_cap);
 	if (rc != EOK) {
 		ddf_log_error("Failed to register irq handler: %s.",
Index: uspace/drv/block/ahci/ahci.c
===================================================================
--- uspace/drv/block/ahci/ahci.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/block/ahci/ahci.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -162,10 +162,4 @@
 }
 
-/** Get AHCI structure from DDF device. */
-static ahci_dev_t *dev_ahci_dev(ddf_dev_t *dev)
-{
-	return ddf_dev_data_get(dev);
-}
-
 /** Get SATA device name.
  *
@@ -891,10 +885,9 @@
  *
  * @param icall The IPC call structure.
- * @param dev   DDF device structure.
- *
- */
-static void ahci_interrupt(ipc_call_t *icall, ddf_dev_t *dev)
-{
-	ahci_dev_t *ahci = dev_ahci_dev(dev);
+ * @param arg   Argument (ahci_dev_t *)
+ */
+static void ahci_interrupt(ipc_call_t *icall, void *arg)
+{
+	ahci_dev_t *ahci = (ahci_dev_t *)arg;
 	unsigned int port = ipc_get_arg1(icall);
 	ahci_port_is_t pxis = ipc_get_arg2(icall);
@@ -1186,5 +1179,6 @@
 	cap_irq_handle_t irq_cap;
 	errno_t rc = register_interrupt_handler(dev,
-	    hw_res_parsed.irqs.irqs[0], ahci_interrupt, &ct, &irq_cap);
+	    hw_res_parsed.irqs.irqs[0], ahci_interrupt, (void *)ahci, &ct,
+	    &irq_cap);
 	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Failed registering interrupt handler.");
Index: uspace/drv/block/ddisk/ddisk.c
===================================================================
--- uspace/drv/block/ddisk/ddisk.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/block/ddisk/ddisk.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -64,5 +64,5 @@
 static void ddisk_bd_connection(ipc_call_t *, void *);
 
-static void ddisk_irq_handler(ipc_call_t *, ddf_dev_t *);
+static void ddisk_irq_handler(ipc_call_t *, void *);
 
 static driver_ops_t driver_ops = {
@@ -176,10 +176,15 @@
 };
 
-void ddisk_irq_handler(ipc_call_t *icall, ddf_dev_t *dev)
+/** Ddisk IRQ handler.
+ *
+ * @param icall IRQ event notification
+ * @param arg Argument (ddisk_t *)
+ */
+void ddisk_irq_handler(ipc_call_t *icall, void *arg)
 {
 	ddf_msg(LVL_DEBUG, "ddisk_irq_handler(), status=%" PRIx32,
 	    (uint32_t) ipc_get_arg1(icall));
 
-	ddisk_t *ddisk = (ddisk_t *) ddf_dev_data_get(dev);
+	ddisk_t *ddisk = (ddisk_t *)arg;
 
 	fibril_mutex_lock(&ddisk->lock);
@@ -512,5 +517,5 @@
 	ddisk_irq_commands[3].addr = (void *) &res_phys->command;
 	rc = register_interrupt_handler(dev, ddisk->ddisk_res.irq,
-	    ddisk_irq_handler, &ddisk_irq_code, &ddisk->irq_cap);
+	    ddisk_irq_handler, (void *)ddisk, &ddisk_irq_code, &ddisk->irq_cap);
 	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Failed to register interrupt handler.");
Index: uspace/drv/block/isa-ide/doc/doxygroups.h
===================================================================
--- uspace/drv/block/isa-ide/doc/doxygroups.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/drv/block/isa-ide/doc/doxygroups.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,4 @@
+/** @addtogroup isa-ide isa-ide
+ * @brief ISA IDE driver
+ * @ingroup drvs
+ */
